<template>
  <div class="card mt-1 mb-0 shadow-none border" :id="'preview_cart_'+file_id">
    <div class="p-2">
      <div class="row align-items-center">
        <div class="col-auto" :id="'preview_'+file_id">
          {{preview(file)}}
        </div>
        <div class="col pl-0">
          <a href="javascript:void(0);" class="text-muted font-weight-bold" data-dz-name>{{file.name}}</a>
        </div>
        <div class="col-auto">
          <!-- Button -->
          <a href="" class="btn btn-link btn-lg text-muted" data-dz-remove @click.prevent="removePreview(file_id)">
            <i class="dripicons-cross"></i>
          </a>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "ImagePreview",
  props:{
    file: {},
    file_id: 0,
    product_image: {
      type: Boolean,
      default: false
    }
  },
  data(){
    return {
      previewEl: '',
    }
  },
  methods: {
    preview(file){
      let reader = new FileReader();
      let preview = this.previewEl;

      if(this.product_image){
        let image = new Image();
        image.height = 100;
        image.title = file.name;
        image.className = 'rounded bg-light';
        image.src = file.original_url;
        if(typeof preview == 'object'){
          preview.appendChild( image );
        }
        return;
      }

      this.images = preview.children;

      if(this.images !== undefined && this.images[0] !== undefined){

        this.images[0].remove();

      }

      reader.addEventListener("load", function () {
        let image = new Image();
        image.height = 100;
        image.title = file.name;
        image.className = 'rounded bg-light';
        image.src = this.result;
        preview.appendChild( image );
      }, false);

      reader.readAsDataURL(file);
    },
    removePreview(file_id){
      document.querySelector('#preview_cart_'+file_id).remove();
      if(this.product_image){
        this.$axios.post('/products/remove_img',{
          'file' : file_id
        })
          .then(resp => {

          })
          .catch(Error => function(){
            console.log(Error)
          });
      }
    }
  },
  mounted() {
    this.previewEl = document.querySelector('#preview_'+this.file_id);
  }
}
</script>

<style scoped>

</style>
